/* m_services.c - Because s_user.c was just crazy.
 *   Copyright (C) 1990 Jarkko Oikarinen and
 *                      University of Oulu, Computing Center
 *
 *   See file AUTHORS in IRC package for additional names of
 *   the programmers.
 *
 *   This program is free softwmare; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 1, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/* $Id: m_services.c,v 1.13 2002/02/04 19:33:33 lucas Exp $ */

/* We've left the originally comments from m_services.c (bahamut) and We think
 * they should be left behind, while the most of the code is from there. 
 * by LHG Team */
	    
#include "client.h"
#include "struct.h"
#include "s_serv.h"
#include "s_conf.h"

/* s_svsnick - Pretty straight forward.  Mostly straight outta df
 *  - Raistlin
 *
 * parv[0] = sender
 * parv[1] = old nickname
 * parv[2] = new nickname
 * parv[3] = timestamp
 *
 * origanal code by Raistlin (from bahamut), posted for hybrid by LHG Team.
 */

int m_svsnick(aClient *cptr, aClient *sptr, int parc, char *parv[])
{
    aClient *acptr;

    if (!find_special_conf(sptr->name, CONF_ULINE) || parc < 3 || (strlen(parv[2]) > NICKLEN)) return 0;

    /* if we can't SVSNICK them to something because the nick
     * is in use, KILL them
     */

    acptr=find_person(parv[2], NULL);
    if(acptr!=NULL)
    {
        /* send a kill out for the person instead --wd */
        sendto_serv_butone(cptr, ":%s KILL %s :%s (SVSNICK Collide)",
                           sptr->name, parv[1], sptr->name);
        /* now send back a kill for the nick they were presumably changed to */
        sendto_one(cptr, ":%s KILL %s :%s (SVSNICK Collide)",
                   sptr->name, parv[2], sptr->name);
        return 0;
    }
    if (!hunt_server(cptr, sptr, ":%s SVSNICK %s %s :%s", 1, parc, parv) != HUNTED_ISME)
    {
        if ((acptr = find_person(parv[1], NULL))!=NULL)
        {
#ifdef ANTI_NICK_FLOOD
            acptr->last_nick_change = atoi(parv[3]);
#endif
            sendto_common_channels(acptr, ":%s NICK :%s", parv[1], parv[2]);
            if (IsPerson(acptr)) add_history(acptr, 1);
            sendto_serv_butone(NULL, ":%s NICK %s :%i", parv[1], parv[2],
                               atoi(parv[3]));
            if(acptr->name[0]) del_from_client_hash_table(acptr->name, acptr);
            strcpy(acptr->name, parv[2]);
            add_to_client_hash_table(parv[2], acptr);
        }
    }
    return 0;
}
